function [krig,skrig,svbloc] = K_auto(data)

% Paramètres pour les variogrammes expérimentaux
nbclas=10;                           % Nombre de classe pour h
lclas=[(0:nbclas-1);(1:nbclas)]'*500;  % Discrétisation des classe
vdir=[0,1,2,3,4,5,6,7]'*22.5;        % Direction anisotropie
vreg=ones(8,1)*10;                   % Tolérance angulaire

% Les variogrammes expérimentaux
figure(1000)
[gexp]=varioexp2d(data,nbclas,lclas,vdir,vreg);

% Paramètres pour l'ajustement des variogrammes expérimentaux
% On ajuste les variogrammes en pondérant en fonction du nombre de paire de points. 
expoh=2;                            % Ici, l'importance est exposant 2
hmin=1;                             % On ajuste par la classe h=0; gérer le bruit
ccode=[0;0];                        % (0 libre et 1 imposé)
modelcode=[1 1 1 1  ;  1 0 0 0];    % (0 libre et 1 imposé), donc on impose l'effet de pépite et le modèle exponentiel
var_seuil = var(data(:,3));
c=[0.1*var_seuil; 0.9*var_seuil];    % Valeur à changer au besoin
model=[1 1 1 1  ; 4 4000 4000 50];     % Valeur à changer au besoin
% Ajustement des variogrammes expérimentaux
figure(2000)
[model,c,~]=ajustermulti(gexp,model,c,modelcode,ccode,vdir,vreg,expoh,hmin);

%% Maintenant les modèles ajustés est dans model et c. Il reste à kriger. 
% La grille de krigeage
xmin = 750; xmax = 11250; dx = 250;
ymin = 750; ymax = 11500; dy = 250;
x0=grille2(xmin,xmax,dx,ymin,ymax,dy);
% icode indique le type de krigeage
itype = 3; % Krigeage ordinaire.
% Moyenne des données (non utile, car krigrage ordinaire). On fournit 0.
avg = 0 ;
% Taille de block à kriger
block = [100 100];
% Discrétisation du bloc;
nd = [4 4];
% Aucune validation croisée
ival = 0;
% Nombre de données dans le voisinnage
nk = 16;
% Rayon de recherche circulaire maximal
r = 9999;
% Nombre de krigé simultannément
ntok = 1; % Un point à la fois
[krig(:,:),skrig(:,:),svbloc(:,:)]=cokri(data,x0,model,c,itype,avg,block,nd,ival,nk,r,ntok);
end