function [esp,fzv]=affine(fz,d2v,d20,ms,seuils)
% fonction pour raliser la correction affine
% fz: fonction de distribution ponctuelle
% d2v: variance de dispersion de blocs
% d20: variance de dispersion de points
% ms: valeurs reprsentatives des seuils
% seuils: seuils ayant servi au codage des indicatrices

[n,m]=size(fz);
esp=fz(:,1)*ms(1);
for i=2:m
  p=fz(:,i)-fz(:,i-1);
  esp=esp+p*ms(i);
end
esp=esp+(1-fz(:,end))*ms(end);

fc=sqrt(d20/d2v);
if fc==1
  return
end

sequiv=(ones(n,1)*seuils-esp*ones(1,m))*fc+esp*ones(1,m);

% pour chaque seuil quivalent, trouver la probabilit correspondante
id=sequiv(:,1)<seuils(1);
fzv(id,1)=sequiv(id,1)/seuils(1).*fz(id,1);
id=sequiv(:,m)>seuils(m);
fzv(id,m)=fz(id,m)+(sequiv(id,m)-seuils(m))/(2*(ms(end)-seuils(m))).*(1-fz(id,m));

for i=1:n;
  for j=2:m-1;
    if sequiv(i,j)<seuils(1)
      fzv(i,j)=sequiv(i,1)/seuils(1).*fz(i,1);
    elseif sequiv(i,j)>seuils(m)
      fz(i,m)+(sequiv(i,m)-seuils(m))/(2*(ms(end)-seuils(m))).*(1-fz(i,m))
    else
      id=find(sequiv(i,j)>seuils(1:end-1) & sequiv(i,j)<=seuils(2:end));
      fzv(i,j)=fz(i,id)+(sequiv(i,j)-seuils(id))/(seuils(id+1)-seuils(id))*(fz(i,id+1)-fz(i,id));
    end
    
  end
end


